Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# PreparedGraphicsObjects Class Reference

A table of objects that are saved within the graphics context for reference by handle later. More...

Inheritance diagram for PreparedGraphicsObjects:

List of all members.

## Public Member Functions
bool | dequeueGeom (Geom geom)
| Removes a geom from the queued list of geoms to be prepared.
bool | dequeueIndexBuffer (GeomPrimitive data)
| Removes a buffer from the queued list of data arrays to be prepared.
bool | dequeueShader (Shader shader)
| Removes a shader from the queued list of shaders to be prepared.
bool | dequeueTexture (Texture tex)
| Removes a texture from the queued list of textures to be prepared.
bool | dequeueVertexBuffer (GeomVertexArrayData data)
| Removes a buffer from the queued list of data arrays to be prepared.
| enqueueGeom (Geom geom)
| Indicates that a geom would like to be put on the list to be prepared when the GSG is next ready to do this (presumably at the next frame).
| enqueueIndexBuffer (GeomPrimitive data)
| Indicates that a buffer would like to be put on the list to be prepared when the GSG is next ready to do this (presumably at the next frame).
| enqueueShader (Shader shader)
| Indicates that a shader would like to be put on the list to be prepared when the GSG is next ready to do this (presumably at the next frame).
| enqueueTexture (Texture tex)
| Indicates that a texture would like to be put on the list to be prepared when the GSG is next ready to do this (presumably at the next frame).
| enqueueVertexBuffer (GeomVertexArrayData data)
| Indicates that a buffer would like to be put on the list to be prepared when the GSG is next ready to do this (presumably at the next frame).
unsigned int | getGraphicsMemoryLimit ()
| Returns the artificial cap on graphics memory that will be imposed on this GSG.
string | getName ()
| Returns the name of the PreparedGraphicsObjects structure.
int | getNumPrepared ()
| Returns the number of objects of any kind that have already been prepared on this GSG.
int | getNumPreparedGeoms ()
| Returns the number of geoms that have already been prepared on this GSG.
int | getNumPreparedIndexBuffers ()
| Returns the number of index buffers that have already been prepared on this GSG.
int | getNumPreparedShaders ()
| Returns the number of shaders that have already been prepared on this GSG.
int | getNumPreparedTextures ()
| Returns the number of textures that have already been prepared on this GSG.
int | getNumPreparedVertexBuffers ()
| Returns the number of vertex buffers that have already been prepared on this GSG.
int | getNumQueued ()
| Returns the number of objects of any kind that have been enqueued to be prepared on this GSG.
int | getNumQueuedGeoms ()
| Returns the number of geoms that have been enqueued to be prepared on this GSG.
int | getNumQueuedIndexBuffers ()
| Returns the number of index buffers that have been enqueued to be prepared on this GSG.
int | getNumQueuedShaders ()
| Returns the number of shaders that have been enqueued to be prepared on this GSG.
int | getNumQueuedTextures ()
| Returns the number of textures that have been enqueued to be prepared on this GSG.
int | getNumQueuedVertexBuffers ()
| Returns the number of vertex buffers that have been enqueued to be prepared on this GSG.
bool | isGeomPrepared (Geom const geom)
| Returns true if the vertex buffer has been prepared on this GSG, false otherwise.
bool | isGeomQueued (Geom const geom)
| Returns true if the geom has been queued on this GSG, false otherwise.
bool | isIndexBufferPrepared (GeomPrimitive const data)
| Returns true if the index buffer has been prepared on this GSG, false otherwise.
bool | isIndexBufferQueued (GeomPrimitive const data)
| Returns true if the index buffer has been queued on this GSG, false otherwise.
bool | isShaderPrepared (Shader const shader)
| Returns true if the shader has been prepared on this GSG, false otherwise.
bool | isShaderQueued (Shader const shader)
| Returns true if the shader has been queued on this GSG, false otherwise.
bool | isTexturePrepared (Texture const tex)
| Returns true if the texture has been prepared on this GSG, false otherwise.
bool | isTextureQueued (Texture const tex)
| Returns true if the texture has been queued on this GSG, false otherwise.
bool | isVertexBufferPrepared (GeomVertexArrayData const data)
| Returns true if the vertex buffer has been prepared on this GSG, false otherwise.
bool | isVertexBufferQueued (GeomVertexArrayData const data)
| Returns true if the vertex buffer has been queued on this GSG, false otherwise.
GeomContext | prepareGeomNow (Geom geom, GraphicsStateGuardianBase gsg)
| Immediately creates a new GeomContext for the indicated geom and returns it.
IndexBufferContext | prepareIndexBufferNow (GeomPrimitive data, GraphicsStateGuardianBase gsg)
| Immediately creates a new IndexBufferContext for the indicated data and returns it.
ShaderContext | prepareShaderNow (Shader shader, GraphicsStateGuardianBase gsg)
| Immediately creates a new ShaderContext for the indicated shader and returns it.
TextureContext | prepareTextureNow (Texture tex, int view, GraphicsStateGuardianBase gsg)
| Immediately creates a new TextureContext for the indicated texture and returns it.
VertexBufferContext | prepareVertexBufferNow (GeomVertexArrayData data, GraphicsStateGuardianBase gsg)
| Immediately creates a new VertexBufferContext for the indicated data and returns it.
| releaseAll ()
| Releases all prepared objects of all kinds at once.
int | releaseAllGeoms ()
| Releases all geoms at once.
int | releaseAllIndexBuffers ()
| Releases all datas at once.
int | releaseAllShaders ()
| Releases all shaders at once.
int | releaseAllTextures ()
| Releases all textures at once.
int | releaseAllVertexBuffers ()
| Releases all datas at once.
| releaseGeom (GeomContext gc)
| Indicates that a geom context, created by a previous call to prepare_geom(), is no longer needed.
| releaseIndexBuffer (IndexBufferContext ibc)
| Indicates that a data context, created by a previous call to prepare_index_buffer(), is no longer needed.
| releaseShader (ShaderContext sc)
| Indicates that a shader context, created by a previous call to prepare_shader(), is no longer needed.
| releaseTexture (Texture tex)
| Releases a texture if it has already been prepared, or removes it from the preparation queue.
| releaseTexture (TextureContext tc)
| Indicates that a texture context, created by a previous call to prepare_texture(), is no longer needed.
| releaseVertexBuffer (VertexBufferContext vbc)
| Indicates that a data context, created by a previous call to prepare_vertex_buffer(), is no longer needed.
| setGraphicsMemoryLimit (unsigned int limit)
| Sets an artificial cap on graphics memory that will be imposed on this GSG.
| showGraphicsMemoryLru (ostream out)
| Writes to the indicated ostream a report of how the various textures and vertex buffers are allocated in the LRU.
| showResidencyTrackers (ostream out)
| Writes to the indicated ostream a report of how the various textures and vertex buffers are allocated in the LRU.

## Detailed Description

A table of objects that are saved within the graphics context for reference by handle later.

Generally, this represents things like OpenGL texture objects or display lists (or their equivalent on other platforms).

This object simply records the pointers to the context objects created by the individual GSG's; these context objects will contain enough information to reference or release the actual object stored within the graphics context.

These tables may potentially be shared between related graphics contexts, hence their storage here in a separate object rather than as a part of the GraphicsStateGuardian.

## Member Function Documentation

bool dequeueGeom | ( | Geom | geom | ) |

Removes a geom from the queued list of geoms to be prepared.

Normally it is not necessary to call this, unless you change your mind about preparing it at the last minute, since the geom will automatically be dequeued and prepared at the next frame.

The return value is true if the geom is successfully dequeued, false if it had not been queued.

bool dequeueIndexBuffer | ( | GeomPrimitive | data | ) |

Removes a buffer from the queued list of data arrays to be prepared.

Normally it is not necessary to call this, unless you change your mind about preparing it at the last minute, since the data will automatically be dequeued and prepared at the next frame.

The return value is true if the buffer is successfully dequeued, false if it had not been queued.

bool dequeueShader | ( | Shader | shader | ) |

Removes a shader from the queued list of shaders to be prepared.

Normally it is not necessary to call this, unless you change your mind about preparing it at the last minute, since the shader will automatically be dequeued and prepared at the next frame.

The return value is true if the shader is successfully dequeued, false if it had not been queued.

bool dequeueTexture | ( | Texture | tex | ) |

Removes a texture from the queued list of textures to be prepared.

Normally it is not necessary to call this, unless you change your mind about preparing it at the last minute, since the texture will automatically be dequeued and prepared at the next frame.

The return value is true if the texture is successfully dequeued, false if it had not been queued.

bool dequeueVertexBuffer | ( | GeomVertexArrayData | data | ) |

Removes a buffer from the queued list of data arrays to be prepared.

Normally it is not necessary to call this, unless you change your mind about preparing it at the last minute, since the data will automatically be dequeued and prepared at the next frame.

The return value is true if the buffer is successfully dequeued, false if it had not been queued.

enqueueGeom | ( | Geom | geom | ) |

Indicates that a geom would like to be put on the list to be prepared when the GSG is next ready to do this (presumably at the next frame).

enqueueIndexBuffer | ( | GeomPrimitive | data | ) |

Indicates that a buffer would like to be put on the list to be prepared when the GSG is next ready to do this (presumably at the next frame).

enqueueShader | ( | Shader | shader | ) |

Indicates that a shader would like to be put on the list to be prepared when the GSG is next ready to do this (presumably at the next frame).

enqueueTexture | ( | Texture | tex | ) |

Indicates that a texture would like to be put on the list to be prepared when the GSG is next ready to do this (presumably at the next frame).

enqueueVertexBuffer | ( | GeomVertexArrayData | data | ) |

Indicates that a buffer would like to be put on the list to be prepared when the GSG is next ready to do this (presumably at the next frame).

unsigned int getGraphicsMemoryLimit | ( |  | ) |

Returns the artificial cap on graphics memory that will be imposed on this GSG.

See set_graphics_memory_limit().

string getName | ( |  | ) |

Returns the name of the PreparedGraphicsObjects structure.

This is an arbitrary name that serves mainly to uniquify the context for PStats reporting.

int getNumPrepared | ( |  | ) |

Returns the number of objects of any kind that have already been prepared on this GSG.

int getNumPreparedGeoms | ( |  | ) |

Returns the number of geoms that have already been prepared on this GSG.

int getNumPreparedIndexBuffers | ( |  | ) |

Returns the number of index buffers that have already been prepared on this GSG.

int getNumPreparedShaders | ( |  | ) |

Returns the number of shaders that have already been prepared on this GSG.

int getNumPreparedTextures | ( |  | ) |

Returns the number of textures that have already been prepared on this GSG.

int getNumPreparedVertexBuffers | ( |  | ) |

Returns the number of vertex buffers that have already been prepared on this GSG.

int getNumQueued | ( |  | ) |

Returns the number of objects of any kind that have been enqueued to be prepared on this GSG.

int getNumQueuedGeoms | ( |  | ) |

Returns the number of geoms that have been enqueued to be prepared on this GSG.

int getNumQueuedIndexBuffers | ( |  | ) |

Returns the number of index buffers that have been enqueued to be prepared on this GSG.

int getNumQueuedShaders | ( |  | ) |

Returns the number of shaders that have been enqueued to be prepared on this GSG.

int getNumQueuedTextures | ( |  | ) |

Returns the number of textures that have been enqueued to be prepared on this GSG.

int getNumQueuedVertexBuffers | ( |  | ) |

Returns the number of vertex buffers that have been enqueued to be prepared on this GSG.

bool isGeomPrepared | ( | Geom const | geom | ) |

Returns true if the vertex buffer has been prepared on this GSG, false otherwise.

bool isGeomQueued | ( | Geom const | geom | ) |

Returns true if the geom has been queued on this GSG, false otherwise.

bool isIndexBufferPrepared | ( | GeomPrimitive const | data | ) |

Returns true if the index buffer has been prepared on this GSG, false otherwise.

bool isIndexBufferQueued | ( | GeomPrimitive const | data | ) |

Returns true if the index buffer has been queued on this GSG, false otherwise.

bool isShaderPrepared | ( | Shader const | shader | ) |

Returns true if the shader has been prepared on this GSG, false otherwise.

bool isShaderQueued | ( | Shader const | shader | ) |

Returns true if the shader has been queued on this GSG, false otherwise.

bool isTexturePrepared | ( | Texture const | tex | ) |

Returns true if the texture has been prepared on this GSG, false otherwise.

bool isTextureQueued | ( | Texture const | tex | ) |

Returns true if the texture has been queued on this GSG, false otherwise.

bool isVertexBufferPrepared | ( | GeomVertexArrayData const | data | ) |

Returns true if the vertex buffer has been prepared on this GSG, false otherwise.

bool isVertexBufferQueued | ( | GeomVertexArrayData const | data | ) |

Returns true if the vertex buffer has been queued on this GSG, false otherwise.

GeomContext prepareGeomNow | ( | Geom | geom,
|  | GraphicsStateGuardianBase | gsg
| ) |  |

Immediately creates a new GeomContext for the indicated geom and returns it.

This assumes that the GraphicsStateGuardian is the currently active rendering context and that it is ready to accept new geoms. If this is not necessarily the case, you should use enqueue_geom() instead.

Normally, this function is not called directly. Call Geom.prepare_now() instead.

The GeomContext contains all of the pertinent information needed by the GSG to keep track of this one particular geom, and will exist as long as the geom is ready to be rendered.

When either the Geom or the PreparedGraphicsObjects object destructs, the GeomContext will be deleted.

IndexBufferContext prepareIndexBufferNow | ( | GeomPrimitive | data,
|  | GraphicsStateGuardianBase | gsg
| ) |  |

Immediately creates a new IndexBufferContext for the indicated data and returns it.

This assumes that the GraphicsStateGuardian is the currently active rendering context and that it is ready to accept new datas. If this is not necessarily the case, you should use enqueue_index_buffer() instead.

Normally, this function is not called directly. Call Data.prepare_now() instead.

The IndexBufferContext contains all of the pertinent information needed by the GSG to keep track of this one particular data, and will exist as long as the data is ready to be rendered.

When either the Data or the PreparedGraphicsObjects object destructs, the IndexBufferContext will be deleted.

ShaderContext prepareShaderNow | ( | Shader | shader,
|  | GraphicsStateGuardianBase | gsg
| ) |  |

Immediately creates a new ShaderContext for the indicated shader and returns it.

This assumes that the GraphicsStateGuardian is the currently active rendering context and that it is ready to accept new shaders. If this is not necessarily the case, you should use enqueue_shader() instead.

Normally, this function is not called directly. Call Shader.prepare_now() instead.

The ShaderContext contains all of the pertinent information needed by the GSG to keep track of this one particular shader, and will exist as long as the shader is ready to be rendered.

When either the Shader or the PreparedGraphicsObjects object destructs, the ShaderContext will be deleted.

TextureContext prepareTextureNow | ( | Texture | tex,
|  | int | view,
|  | GraphicsStateGuardianBase | gsg
| ) |  |

Immediately creates a new TextureContext for the indicated texture and returns it.

This assumes that the GraphicsStateGuardian is the currently active rendering context and that it is ready to accept new textures. If this is not necessarily the case, you should use enqueue_texture() instead.

Normally, this function is not called directly. Call Texture.prepare_now() instead.

The TextureContext contains all of the pertinent information needed by the GSG to keep track of this one particular texture, and will exist as long as the texture is ready to be rendered.

When either the Texture or the PreparedGraphicsObjects object destructs, the TextureContext will be deleted.

VertexBufferContext prepareVertexBufferNow | ( | GeomVertexArrayData | data,
|  | GraphicsStateGuardianBase | gsg
| ) |  |

Immediately creates a new VertexBufferContext for the indicated data and returns it.

This assumes that the GraphicsStateGuardian is the currently active rendering context and that it is ready to accept new datas. If this is not necessarily the case, you should use enqueue_vertex_buffer() instead.

Normally, this function is not called directly. Call Data.prepare_now() instead.

The VertexBufferContext contains all of the pertinent information needed by the GSG to keep track of this one particular data, and will exist as long as the data is ready to be rendered.

When either the Data or the PreparedGraphicsObjects object destructs, the VertexBufferContext will be deleted.

releaseAll | ( |  | ) |

Releases all prepared objects of all kinds at once.

int releaseAllGeoms | ( |  | ) |

Releases all geoms at once.

This will force them to be reloaded into geom memory for all GSG's that share this object. Returns the number of geoms released.

int releaseAllIndexBuffers | ( |  | ) |

Releases all datas at once.

This will force them to be reloaded into data memory for all GSG's that share this object. Returns the number of datas released.

int releaseAllShaders | ( |  | ) |

Releases all shaders at once.

This will force them to be reloaded into shader memory for all GSG's that share this object. Returns the number of shaders released.

int releaseAllTextures | ( |  | ) |

Releases all textures at once.

This will force them to be reloaded into texture memory for all GSG's that share this object. Returns the number of textures released.

int releaseAllVertexBuffers | ( |  | ) |

Releases all datas at once.

This will force them to be reloaded into data memory for all GSG's that share this object. Returns the number of datas released.

releaseGeom | ( | GeomContext | gc | ) |

Indicates that a geom context, created by a previous call to prepare_geom(), is no longer needed.

The driver resources will not be freed until some GSG calls update(), indicating it is at a stage where it is ready to release geoms--this prevents conflicts from threading or multiple GSG's sharing geoms (we have no way of knowing which graphics context is currently active, or what state it's in, at the time release_geom is called).

releaseIndexBuffer | ( | IndexBufferContext | ibc | ) |

Indicates that a data context, created by a previous call to prepare_index_buffer(), is no longer needed.

The driver resources will not be freed until some GSG calls update(), indicating it is at a stage where it is ready to release datas--this prevents conflicts from threading or multiple GSG's sharing datas (we have no way of knowing which graphics context is currently active, or what state it's in, at the time release_index_buffer is called).

releaseShader | ( | ShaderContext | sc | ) |

Indicates that a shader context, created by a previous call to prepare_shader(), is no longer needed.

The driver resources will not be freed until some GSG calls update(), indicating it is at a stage where it is ready to release shaders--this prevents conflicts from threading or multiple GSG's sharing shaders (we have no way of knowing which graphics context is currently active, or what state it's in, at the time release_shader is called).

releaseTexture | ( | Texture | tex | ) |

Releases a texture if it has already been prepared, or removes it from the preparation queue.

releaseTexture | ( | TextureContext | tc | ) |

Indicates that a texture context, created by a previous call to prepare_texture(), is no longer needed.

The driver resources will not be freed until some GSG calls update(), indicating it is at a stage where it is ready to release textures--this prevents conflicts from threading or multiple GSG's sharing textures (we have no way of knowing which graphics context is currently active, or what state it's in, at the time release_texture is called).

releaseVertexBuffer | ( | VertexBufferContext | vbc | ) |

Indicates that a data context, created by a previous call to prepare_vertex_buffer(), is no longer needed.

The driver resources will not be freed until some GSG calls update(), indicating it is at a stage where it is ready to release datas--this prevents conflicts from threading or multiple GSG's sharing datas (we have no way of knowing which graphics context is currently active, or what state it's in, at the time release_vertex_buffer is called).

setGraphicsMemoryLimit | ( | unsigned int | limit | ) |

Sets an artificial cap on graphics memory that will be imposed on this GSG.

This limits the total amount of graphics memory, including texture memory and vertex buffer memory, that will be consumed by the GSG, regardless of whether the hardware claims to provide more graphics memory than this. It is useful to put a ceiling on graphics memory consumed, since some drivers seem to allow the application to consume more memory than the hardware can realistically support.

showGraphicsMemoryLru | ( | ostream | out | ) |

Writes to the indicated ostream a report of how the various textures and vertex buffers are allocated in the LRU.

showResidencyTrackers | ( | ostream | out | ) |

Writes to the indicated ostream a report of how the various textures and vertex buffers are allocated in the LRU.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties